!!ARBfp1.0

ATTRIB iColor = fragment.color.primary;
ATTRIB iCoord = fragment.texcoord;

PARAM graydesc = program.local[0]; # x: luminosity; y: intensivity;

OUTPUT oColor = result.color;

#---------#
# Program #
#---------#

# mix texture & primary color
TEMP samp;
TXP samp, iCoord, texture, 2D;
TEMP out;
MUL out, samp, iColor;

# convert to gray scale
TEMP src;
MOV src, out;
MUL samp.r, out.r, 0.30;
MUL samp.g, out.g, 0.59;
MUL samp.b, out.b, 0.11;
MOV out, 0.0;
ADD out, out, samp.r;
ADD out, out, samp.g;
ADD out, out, samp.b;
MUL out, out, graydesc.x;
MUL out, out, graydesc.y;
TEMP dst;
ADD dst, 1.0, -graydesc.y;
MUL dst, src, dst;
ADD out, dst, out;
MOV out.a, src.a;

# set output
MOV oColor, out;

END